/*
 * A file to handle a bunch of categories.
 * @Shahzad Ali
 */

class categories {
public:
  categories(int n, double r_th, long d_rate, char* outfile);
  ~categories();
  void increment_Nr(long n);
  int next_available();
  int index(char * n, short fl);
  category* get_category(char * n, short fl);
  category* new_category(char *n);
  int train(char* fn);
  int test(char* fn);
  double chi_square(double x, double n);
  void calc_Qn();
  int total_cats();
  void print_result(char* n, long num);
  void calc_frequencies();
  category* get_rare();
  category* get_new();
  void pack();
  void print_table(ostream& tout);
protected:
  ofstream fout;        /* Output stream handle */
  int num_cats;           /* Number of categories */
  int next_free;          /* Next free available */
  int total_records;      /* Total number of records in the training file */
  double rare_threshold;  /* Threshold to decide rare categories */
  double decay_rate;      /* Decay rate for the Q measure */
  double Nr;              /* Estimate of the number of records at this time */
  double Qn;              /* Q-statistic at a point in time */
  double prev_Qn;              /* Prev Q-statistic at a point in time */
  category** frequency_table;
};
