/*
*   Definition of the categories data-structure
*   @Shahzad Ali
*/


#include "defs.h"

class category {
public:
  category(char *n, int len, short fl);
  ~category();
  char* get_name() { return name; }
  void set_name(char *n, int len);
  int increment();
  int decrement();
  void calc_freq(long total) { (total) ?freq = (double)fm/(double)total
				       :freq = 0.0;}
  void calc_g_freq(double Nr, double r, int saw);
  double calc_Qn(double Nr);
  double get_freq() { return freq; }
  double get_g_freq() { return g_freq; }
  long get_fm() { return fm; }
  void set_fm(long new_fm) { fm = new_fm; }
  void set_flag(short fl) { flags |= fl; }
  void reset_flag(short fl) { flags &= ~fl; }
  int  isspecial() { return flags&CAT_SPECIAL; }
  void validate() { valid = TRUE; }
  void invalidate();
  int  isvalid() { return valid; }
protected:
  int valid;
  char * name;
  long fm;               /* Actual number of records seen */
  double freq;           /* Frequency of the records seen */
  double g_freq;         /* Current frequency from the given test file */
  short flags;
};
