/*
 * Main file
 * @Shahzad Ali
 */

#include "defs.h"
#include "category.h"
#include "categories.h"

void main(int argc, char **argv) {
  int c, num=0, len=0;
  char *filename = NULL, *outfile = NULL, *testfile = NULL;
  double rare_th = DEFAULT_RARE_THRESHOLD;
  long decay_rate = DEFAULT_DECAY_RATE;

  while ((c =getopt(argc, argv, "n:f:r:d:o:t:")) != -1){
    switch (c) {
    case 'n': {
      num = atoi(optarg);
      break;
    }
    case 'r': {
      rare_th = atof(optarg);
      break;
    }
    case 'd': {
      decay_rate = atol(optarg);
      break;
    }
    case 'o': {
      len = strlen(optarg);
      outfile = new char[len + 1];
      if (!outfile){
	cout << "Out of mem" << endl;
	exit(1);
      }
      strncpy(outfile, optarg, len);
      outfile[len] = '\0';
      break;
    }
    case 't': {
      len = strlen(optarg);
      testfile = new char[len + 1];
      if (!testfile){
	cout << "Out of mem" << endl;
	exit(1);
      }
      strncpy(testfile, optarg, len);
      testfile[len] = '\0';
      break;
    }
    case 'f': {
      len = strlen(optarg);
      filename = new char[len + 1];
      if (!filename){
	cout << "Out of mem" << endl;
	exit(1);
      }
      strncpy(filename, optarg, len);
      filename[len] = '\0';
      break;
    }
    case '?': {
      cout << "What the hell is this!!" << endl;
      cout << "command [-n num_of_categories] [-f training_filename]" << endl;
      exit (1);
    }
    default: {
      cout << "Unknown flag" << endl;
      exit(1);
    }
    }
  }    
    /* If there was one more argument to check for 
     *   if (optinf != (argc-1)){
     *     error;
     * }
     * variable = optind;
     */
    if (!filename){
      cout << "What the hell is this!!" << endl;
      cout << "command [-n num_of_categories] [-f training_filename]" << endl;
      exit (1);
    }
    if (!testfile){
      cout << "What the hell is this!!" << endl;
      cout << "<prog> -n num_of_categories -f training_filename" 
	   << " [-r half_life] [-o output_filename] -t test_filename" <<endl;
      exit (1);
    }
    if (num < 1){
      cout << "Are there no categories??" << endl;
      exit(1);
    }
    
    /* Initialize the categories structure */
    categories ftable(num, rare_th, decay_rate, outfile);
    cout << "Opening " << filename << " and looking for " 
	 << num << " categories" << endl;
    ftable.train(filename);
    cout << "read it" << endl;
    ftable.calc_frequencies();
    ftable.pack();
    cout << "And this is the frequency table..." << endl;
    ftable.print_table(cout);
    ftable.test(testfile);
    exit(0);
}
